
#include "fm-tree-view.h"
#include "fm-tree-model.h"
#include "fm-uri-convert.h"

#include <string.h>
#include <eel/eel-gtk-extensions.h>
#include <gtk/gtk.h>
#include <glib/gi18n.h>
#include <gio/gio.h>
#include <libcaja-private/caja-clipboard.h>
#include <libcaja-private/caja-clipboard-monitor.h>
#include <libcaja-private/caja-desktop-icon-file.h>
#include <libcaja-private/caja-debug-log.h>
#include <libcaja-private/caja-file-attributes.h>
#include <libcaja-private/caja-file-operations.h>
#include <libcaja-private/caja-file-utilities.h>
#include <libcaja-private/caja-global-preferences.h>
#include <libcaja-private/caja-icon-names.h>
#include <libcaja-private/caja-program-choosing.h>
#include <libcaja-private/caja-tree-view-drag-dest.h>
#include <libcaja-private/caja-sidebar-provider.h>
#include <libcaja-private/caja-module.h>
#include <libcaja-private/caja-window-info.h>
#include <libcaja-private/caja-window-slot-info.h>
/*
#define PERSONAL_FILE "personal:///"
#define PERSONAL_DOCUMENT_LINK_FILE "personal:///documents.link"
#define PERSONAL_DOWNLOAD_LINK_FILE "personal:///download.link"
#define PERSONAL_PICTURES_LINK_FILE "personal:///pictures.link"
#define PERSONAL_MUSIC_LINK_FILE "personal:///music.link"
#define PERSONAL_VIDEOS_LINK_FILE "personal:///videos.link"
*/
#define BUFF_PATH_LEN 1024

#define FAVORITE_FILE "favorite:///"
#define FAVORITE_DESKTOP_LINK_FILE "favorite:///desktop.link"
#define FAVORITE_TRASH_LINK_FILE "favorite:///trash.link"
#define FAVORITE_RECENT_LINK_FILE "favorite:///recent.link"
#define TRASH_FILE "trash:///"
#define RECENT_FILE "recent:///"
#define COMPUTER_FILE "computer:///"
#define MOUNT_FILE "file:///media"
#define FILESYSYTEM "file:///"
#define COMPUTER_FILESYSTEM "computer:///root.link"
#define BURN "burn:///"
#define FTP "ftp://"
#define SFTP "sftp://"
#define SMB "smb://"
#define DRIVE_NUMBER 64

CajaFile *
file_proto_file_convert_2_our_proto_file (CajaFile *file_proto_file)
{
    CajaFile *our_proto_file = NULL;
    char *our_proto_path;
    const char *dst_file_path;
    int dst_len;
    int our_proto_len;
    int file_pro_len;
    char *uri,*activation_uri;
    char *src_file_path;
    int src_len;
	int m;
    GList *l;
    if (file_proto_file == NULL)
        return NULL;

    file_pro_len = strlen("file://");
    uri = caja_file_get_uri(file_proto_file);
    src_file_path = g_uri_unescape_string (uri, "");
    src_len = strlen(src_file_path);

    our_proto_path = g_new0(char, BUFF_PATH_LEN);

    /*
    dst_file_path = g_get_user_special_dir (G_USER_DIRECTORY_DOCUMENTS);
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path + file_pro_len, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(PERSONAL_DOCUMENT_LINK_FILE);
        strncpy(our_proto_path, PERSONAL_DOCUMENT_LINK_FILE, our_proto_len);
        strncpy(our_proto_path + our_proto_len, src_file_path + file_pro_len + dst_len, src_len -  file_pro_len - dst_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }

    dst_file_path = g_get_user_special_dir (G_USER_DIRECTORY_DOWNLOAD);
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path + file_pro_len, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(PERSONAL_DOWNLOAD_LINK_FILE);
        strncpy(our_proto_path, PERSONAL_DOWNLOAD_LINK_FILE, our_proto_len);
        strncpy(our_proto_path + our_proto_len, src_file_path + file_pro_len + dst_len, src_len -  file_pro_len - dst_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }

    dst_file_path = g_get_user_special_dir (G_USER_DIRECTORY_MUSIC);
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path + file_pro_len, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(PERSONAL_MUSIC_LINK_FILE);
        strncpy(our_proto_path, PERSONAL_MUSIC_LINK_FILE, our_proto_len);
        strncpy(our_proto_path + our_proto_len, src_file_path + file_pro_len + dst_len, src_len -  file_pro_len - dst_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }

    dst_file_path = g_get_user_special_dir (G_USER_DIRECTORY_PICTURES);
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path + file_pro_len, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(PERSONAL_PICTURES_LINK_FILE);
        strncpy(our_proto_path, PERSONAL_PICTURES_LINK_FILE, our_proto_len);
        strncpy(our_proto_path + our_proto_len, src_file_path + file_pro_len + dst_len, src_len -  file_pro_len - dst_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }

    dst_file_path = g_get_user_special_dir (G_USER_DIRECTORY_VIDEOS);
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path + file_pro_len, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(PERSONAL_VIDEOS_LINK_FILE);
        strncpy(our_proto_path, PERSONAL_VIDEOS_LINK_FILE, our_proto_len);
        strncpy(our_proto_path + our_proto_len, src_file_path + file_pro_len + dst_len, src_len -  file_pro_len - dst_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }
    */

    dst_file_path = g_get_user_special_dir (G_USER_DIRECTORY_DESKTOP);
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path + file_pro_len, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(FAVORITE_DESKTOP_LINK_FILE);
        strncpy(our_proto_path, FAVORITE_DESKTOP_LINK_FILE, our_proto_len);
        strncpy(our_proto_path + our_proto_len, src_file_path + file_pro_len + dst_len, src_len -  file_pro_len - dst_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }

    dst_file_path = TRASH_FILE;
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(FAVORITE_TRASH_LINK_FILE);
        strncpy(our_proto_path, FAVORITE_TRASH_LINK_FILE, our_proto_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }

    dst_file_path = RECENT_FILE;
    dst_len = strlen(dst_file_path);
    if (strncmp(src_file_path, dst_file_path, dst_len) == 0)
    {
        our_proto_len = strlen(FAVORITE_RECENT_LINK_FILE);
        strncpy(our_proto_path, FAVORITE_RECENT_LINK_FILE, our_proto_len);

        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }

    //这里只把/home/{name}替换到“个人”节点，其他不做替换，
    //否则会导致左树“我的电脑”下的个人目录下节点无法展开。by lenky
    /*
    dst_file_path = g_get_home_dir ();
    if (strcmp(src_file_path + file_pro_len, dst_file_path) == 0)
    {
        our_proto_len = strlen(PERSONAL_FILE);
        strncpy(our_proto_path, PERSONAL_FILE, our_proto_len);
        our_proto_file = caja_file_get_by_uri (our_proto_path);
        goto ret;
    }
    */
	dst_len = strlen(MOUNT_FILE);
    for(l=g_hash_table_get_keys(hashtable());l!=NULL;l=l->next)
    {
        activation_uri = g_hash_table_lookup(hashtable(),l->data);
		activation_uri = g_uri_unescape_string(activation_uri,"");
        if(strcmp(activation_uri,FILESYSYTEM)==0)
            continue;
        if(strncmp(src_file_path,activation_uri,strlen(activation_uri))==0)
        {
            strncpy(our_proto_path,COMPUTER_FILE,strlen(COMPUTER_FILE));
            strncpy(our_proto_path+strlen(COMPUTER_FILE),(char *)l->data,strlen((char *)l->data));
            if (strncmp(activation_uri, COMPUTER_FILE, strlen(COMPUTER_FILE)) == 0)
                continue;
            strncpy(our_proto_path+strlen(our_proto_path),src_file_path+strlen(activation_uri),strlen(src_file_path)-strlen(activation_uri));
            our_proto_file = caja_file_get_by_uri(our_proto_path);
            goto ret;
        } 
    }

	if(strcmp(src_file_path,"file:///")==0)
	{
        strcpy(our_proto_path,COMPUTER_FILESYSTEM);
        our_proto_file = caja_file_get_by_uri(our_proto_path);
        goto ret;	
	}
    
	dst_len = strlen(FILESYSYTEM);
	if (strncmp(src_file_path,FILESYSYTEM,dst_len)==0)
	{
        for(l=g_hash_table_get_keys(hashtable());l!=NULL;l=l->next)
    	{
        	activation_uri = g_hash_table_lookup(hashtable(),l->data);
        	if(strcmp(activation_uri,FILESYSYTEM)==0)
        	{
                strncpy(our_proto_path,COMPUTER_FILE,strlen(COMPUTER_FILE));
                strncpy(our_proto_path+strlen(COMPUTER_FILE),(char *)l->data,strlen((char *)l->data));
                strcpy(our_proto_path+strlen(our_proto_path),"/");
                strncpy(our_proto_path+strlen(our_proto_path),src_file_path+strlen(FILESYSYTEM),strlen(src_file_path)-strlen(g_uri_unescape_string (activation_uri, "")));
            	our_proto_file = caja_file_get_by_uri(our_proto_path);
            	goto ret;	
        	}
    	}
	}

ret:
    g_free(our_proto_path);
    g_free (src_file_path);
    g_free(uri);

    return our_proto_file;
}

CajaFile *
caja_file_get_special_parent (CajaFile *file)
{
    CajaFile *parent_file = caja_file_get_parent(file);

    if(caja_file_is_desktop_directory(parent_file))
	return parent_file;
    if(parent_file!=NULL)
        if(caja_file_is_desktop_directory(parent_file))
            return parent_file;
    CajaFile *our_proto_file = file_proto_file_convert_2_our_proto_file (parent_file);

    if (our_proto_file != NULL)
    {
        caja_file_unref (parent_file);
        return our_proto_file;
    }
    else
        return parent_file;
}

static GString *
get_real_computer_uri(CajaFile *file,char* suffix_name,GMount *mount,char *default_location)
{
    CajaFile *vr_file;
    char* uri,*vr_uri;
    char* drive_name;
    GString *str;
    GDrive *drive;
    char temp_str[4096]; 
    int i;
    char temp[4096];

    i = 0;
    memset(temp,0,sizeof(temp));
    memset(temp_str,0,sizeof(temp_str));
    drive = g_mount_get_drive(mount);
    drive_name = g_drive_get_name(drive);
    uri = caja_file_get_activation_uri(file);
    sprintf (temp,"%s%s",drive_name,suffix_name);

     while(1)
    {    
        sprintf (temp_str,"%s%s%s",COMPUTER_FILE,temp,uri+strlen(default_location));
        str = g_string_new(temp_str);
        vr_file = caja_file_get_by_uri (str->str);
        vr_uri = caja_file_get_activation_uri(vr_file);
        
        if(strcmp(uri,vr_uri) == 0)
        {
            break;
        }
        i++;
        memset(temp,0,sizeof(temp));
        memset(temp_str,0,sizeof(temp_str));
        sprintf (temp,"%s-%d%s",drive_name,i,suffix_name);
        if(i>100)
            break;
    }
    return str;
    g_object_unref(drive);
    g_free(drive_name);
    g_free(temp);
}

static gboolean
location_is_in_the_mount(const char* uri,const char*location)
{
   return  (strncmp(uri,location,strlen(location))==0
        &&(uri[strlen(location)]=='\0'||uri[strlen(location)]=='/'));
}

void caja_location_convert_filesystem_2_gvfs (const char* uri,GString **str,CajaFile* file)
{
	GVolumeMonitor* volume_monitor;
	GList*l,*mounts;
	GMount* mount;
	GFile* g_file;
	char *default_location,*mount_name;
           char* suffix_name,*suffix_mount_name;

            if(file==NULL)
                return;
            if(g_str_has_prefix(uri,FTP)||g_str_has_prefix (uri,SMB)||g_str_has_prefix(uri,SFTP))
                return;
	if(g_str_has_prefix (uri,COMPUTER_FILE))
	{
		*str = g_string_new (uri);
	}		

	volume_monitor = g_volume_monitor_get();
	mounts = g_volume_monitor_get_mounts (volume_monitor);
	suffix_name = ".drive";
	suffix_mount_name=".mount";
	for(l=mounts;l!=NULL;l=l->next)
	{
                mount = l->data;
                g_file = g_mount_get_default_location (mount);
                default_location = g_file_get_uri(g_file);
                if(location_is_in_the_mount(uri,default_location))
                {
                    *str = get_real_computer_uri(file,suffix_name, mount,default_location);
                }
                g_object_unref(g_file);
                g_free(default_location);
	}
	g_list_free(mounts);
	g_object_unref(volume_monitor);
	
//	return str;
}

gboolean has_common_parent(char* str1,char* str2)
{
    int len,i;
    if(str1==NULL||str2==NULL)
            return FALSE;
    if(strlen(str1)>strlen(str2))
        len = strlen(str1);
    else
        len = strlen(str2);
    for(i=0;i<=len;i++)
    {
            if(str1[i]!=str2[i])
                return FALSE;
            if(i==len)
                if((str1[i]=='/'||str1[i]=='\0')&&(str2[i]=='\0'||str2[i]=='/'))
                    return TRUE;
     }
    return FALSE;
}

//=========================================================================//
GString *caja_location_convert_machine_2_human_read(const char *location)
{
	if(NULL == location)
	{
		return g_string_new(_(""));
	}
    if (strcmp(location, COMPUTER_FILE) == 0)
    {
        return g_string_new(_("My Computer"));
    }
    /*
    if (strcmp(location, PERSONAL_FILE) == 0)
    {
        return g_string_new(_("Personal"));
    }
    */
    if (strcmp(location, FAVORITE_FILE) == 0)
    {
        return g_string_new(_("Favorite"));
    }
    
    if (strcmp(location, TRASH_FILE) == 0)
    {
        GString *favorite_trash_dir = g_string_new((_("Favorite")));
        favorite_trash_dir = g_string_append(favorite_trash_dir, "/");
        favorite_trash_dir = g_string_append(favorite_trash_dir, _("Trash"));
        return favorite_trash_dir;
    }
    
    if (strcmp(location, RECENT_FILE) == 0)
    {
        GString *favorite_recent_dir = g_string_new((_("Favorite")));
        favorite_recent_dir = g_string_append(favorite_recent_dir, "/");
        favorite_recent_dir = g_string_append(favorite_recent_dir, _("Recent"));
        return favorite_recent_dir;
    }
    
    //********** 2016.10.24 the bug of copy /data ******************//

    if(strncmp(location, COMPUTER_FILE,strlen(COMPUTER_FILE)) == 0)
    {
        char *activation_uri;
        GList *l;
        for(l=g_hash_table_get_keys(hashtable());l!=NULL;l=l->next)
        {
            char *name = l->data;
            GString  *target_uri;
            GString *string;
            GString *temp;
            location = g_uri_unescape_string(location,"");
            target_uri = g_string_new("computer:///");
            target_uri = g_string_append(target_uri,name);
            if(has_common_parent(target_uri->str,location))//if(strncmp(target_uri->str,location,strlen(target_uri->str))==0)
            {
                temp = g_string_new("");
                g_strlcpy(temp->str, location+strlen(target_uri->str),strlen(location) - strlen(target_uri->str)+1);
                activation_uri = g_hash_table_lookup(hashtable(),l->data);
                activation_uri = g_uri_unescape_string(activation_uri,"");
                string = g_string_new(activation_uri);
                string = g_string_append(string, temp->str);
                if(activation_uri!=NULL)
                    g_free(activation_uri);
                g_free(location);
                return string;
            }
            g_free(location);
        }
    }

    //**************************************************************//    
    const char* home_dir = g_get_home_dir();
    int home_dir_len = strlen(g_get_home_dir());

    if (has_common_parent(location,home_dir))
    {
        const char *desktop = g_get_user_special_dir (G_USER_DIRECTORY_DESKTOP);
        int desktop_len = strlen(desktop);

        if (strncmp(location, desktop, desktop_len) == 0)
        {
            GString *favorite_desktop_dir = g_string_new((_("Favorite")));
            favorite_desktop_dir = g_string_append(favorite_desktop_dir, "/");
            favorite_desktop_dir = g_string_append(favorite_desktop_dir, _("Desktop"));
            favorite_desktop_dir = g_string_append(favorite_desktop_dir, location + desktop_len);
            return favorite_desktop_dir;
        }
        else if (strncmp(location + home_dir_len, "/.local/share/Trash/files", strlen("/.local/share/Trash/files")) == 0)
        {
            GString *favorite_trash_dir = g_string_new((_("Favorite")));
            favorite_trash_dir = g_string_append(favorite_trash_dir, "/");
            favorite_trash_dir = g_string_append(favorite_trash_dir, _("Trash"));
            favorite_trash_dir = g_string_append(favorite_trash_dir, location + home_dir_len + strlen("/.local/share/Trash/files"));
            return favorite_trash_dir;
        }
        else
        {
            GString *personal_dir = g_string_new((_("Personal")));
            personal_dir = g_string_append(personal_dir, location + home_dir_len);
            return personal_dir;
        }
    }

    return g_string_new(location);
}

GString *caja_location_convert_human_read_2_machine(const char *location)
{
    if (strcmp(location, _("My Computer")) == 0)
    {
        return g_string_new(COMPUTER_FILE);
    }
    /*
    if (strcmp(location, _("Personal")) == 0)
    {
        return g_string_new(PERSONAL_FILE);
    }
    */
    if (strcmp(location, _("Favorite")) == 0)
    {
        return g_string_new(FAVORITE_FILE);
    }

    GString *favorite_trash_dir = g_string_new((_("Favorite")));
    favorite_trash_dir = g_string_append(favorite_trash_dir, "/");
    favorite_trash_dir = g_string_append(favorite_trash_dir, _("Trash"));
    if (strcmp(location, favorite_trash_dir->str) == 0)
    {
        g_string_free(favorite_trash_dir, TRUE);
        return g_string_new(TRASH_FILE);
    }
    g_string_free(favorite_trash_dir, TRUE);

    GString *favorite_recent_dir = g_string_new((_("Favorite")));
    favorite_recent_dir = g_string_append(favorite_recent_dir, "/");
    favorite_recent_dir = g_string_append(favorite_recent_dir, _("Recent"));
    if (strcmp(location, favorite_recent_dir->str) == 0)
    {
        g_string_free(favorite_recent_dir, TRUE);
        return g_string_new(RECENT_FILE);
    }
    g_string_free(favorite_recent_dir, TRUE);
    
    const char* home_dir = g_get_home_dir();
    int home_dir_len = strlen(g_get_home_dir());

    GString *favorite_desktop_dir = g_string_new((_("Favorite")));
    favorite_desktop_dir = g_string_append(favorite_desktop_dir, "/");
    favorite_desktop_dir = g_string_append(favorite_desktop_dir, _("Desktop"));
    int favorite_desktop_dir_len = strlen(favorite_desktop_dir->str);
    if (strncmp(location, favorite_desktop_dir->str, favorite_desktop_dir_len) == 0)
    {
        GString *desktop = g_string_new(g_get_user_special_dir (G_USER_DIRECTORY_DESKTOP));
        desktop = g_string_append(desktop, location + favorite_desktop_dir_len);
        g_string_free(favorite_desktop_dir, TRUE);
        return desktop;
    }
    g_string_free(favorite_desktop_dir, TRUE);

    GString *favorite_trash_dir2 = g_string_new((_("Favorite")));
    favorite_trash_dir2 = g_string_append(favorite_trash_dir2, "/");
    favorite_trash_dir2 = g_string_append(favorite_trash_dir2, _("Trash"));
    int favorite_trash_dir2_len = strlen(favorite_trash_dir2->str);
    if (strncmp(location, favorite_trash_dir2->str, favorite_trash_dir2_len) == 0)
    {
        GString *trash = g_string_new(home_dir);
        trash = g_string_append(trash, "/.local/share/Trash/files");
        trash = g_string_append(trash, location + favorite_trash_dir2_len);
        g_string_free(favorite_trash_dir2, TRUE);
        return trash;
    }
    g_string_free(favorite_trash_dir2, TRUE);

    GString *personal_dir = g_string_new((_("Personal")));
    int personal_dir_len = strlen(personal_dir->str);
    if (strncmp(location, personal_dir->str, personal_dir_len) == 0)
    {
        GString *personal = g_string_new(home_dir);
        personal = g_string_append(personal, location + personal_dir_len);
        g_string_free(personal_dir, TRUE);
        return personal;
    }
    g_string_free(personal_dir, TRUE);

    return g_string_new(location);
}

//过滤caja文件：对在parent下的file进行判断是否需要过滤，TRUE为是，FALSE为否
gboolean filterCajaFile(CajaFile *parent, CajaFile *file)
{
    if (parent == NULL || file == NULL)
        return FALSE;

    char *parent_uri = caja_file_get_uri(parent);
    char *parent_file_path = g_uri_unescape_string (parent_uri, "");
    char *file_uri = caja_file_get_uri(file);
    char *file_file_path = g_uri_unescape_string (file_uri, "");
    gboolean ret = FALSE;
    int file_pro_len = strlen("file://");
    const char *home_file_path = g_get_home_dir();
    int home_file_path_len = strlen(home_file_path);

    //Debug
    //fprintf(stderr, "parent_file_path + file_pro_len:%s\thome_file_path:%s\tfile_file_path:%s\n", 
    //    parent_file_path + file_pro_len, home_file_path, file_file_path);

    //对个人目录进行过滤
    if (strcmp(parent_file_path + file_pro_len, home_file_path) == 0)
    {

        //Debug
        //fprintf(stderr, "file_file_path + home_file_path_len + 1:%s\n", file_file_path + file_pro_len + home_file_path_len + 1);

/*
        if (strcmp(file_file_path + file_pro_len + home_file_path_len + 1, _("Home-Desktop")) == 0 ||
            strcmp (file_file_path + file_pro_len + home_file_path_len + 1, "Desktop") == 0)
        {
            ret = TRUE;
        }
*/
    }

    g_free(parent_file_path);
    g_free(parent_uri);
    g_free(file_file_path);
    g_free(file_uri);
    return ret;
}

static gboolean
check_has_subdirectory (const char *parent_uri)
{
    gboolean ret = FALSE;
    char *parent_dir = g_uri_unescape_string (parent_uri, "");
    GDir *dir = g_dir_open(parent_dir, 0, NULL);
    const gchar *dir_name, *full_name;

	if (dir)
	{
    	while(dir_name = g_dir_read_name(dir))
    	{
    	    if(strcmp(dir_name,"lost+found")==0||strncmp(dir_name,".",1)==0)
            {
                    ret = FALSE;
                    continue;
            }   
        	        full_name = g_build_filename(parent_dir, dir_name, NULL);

        	        if (g_file_test(full_name, G_FILE_TEST_IS_DIR))
        	        {
            	ret = TRUE;
            	break;
        	            }
    	        }
		g_dir_close(dir);
	}
    g_free (parent_dir);

    return ret;
}

gboolean 
check_has_child(char *uri)
{
    if (strcmp(uri, FAVORITE_FILE) == 0 ||
       strcmp(uri, COMPUTER_FILE) == 0)
    {
        return TRUE;
    }

    if (strcmp(uri, FAVORITE_DESKTOP_LINK_FILE) == 0)
    {
        //对于桌面不显示子节点
        return FALSE;
        //return check_has_subdirectory(g_get_user_special_dir (G_USER_DIRECTORY_DESKTOP));
    }

    if (strncmp(uri, FILESYSYTEM, strlen(FILESYSYTEM)) == 0)
    {
        return check_has_subdirectory(uri + strlen(FILESYSYTEM) - 1);
    }

    //if (strncmp(uri, COMPUTER_FILESYSTEM, strlen(COMPUTER_FILESYSTEM)) == 0)
    //{
    //    return check_has_subdirectory("/");
    //}

    if (strncmp(uri, COMPUTER_FILE, strlen(COMPUTER_FILE)) == 0)
    {
        //return check_has_subdirectory(uri + strlen(FILESYSYTEM) - 1);
        gboolean ret = FALSE;
        GList *l;
        char *unescape_uri = g_uri_unescape_string (uri, "");
        char *mount_dir;
        char *path;
        for (l = g_hash_table_get_keys(hashtable()); l != NULL; l = l->next)
        {
            mount_dir = g_hash_table_lookup(hashtable(), l->data);
            if (strncmp(unescape_uri + strlen(COMPUTER_FILE), (char *)l->data, strlen((char *)l->data)) == 0)
            {
                path = unescape_uri + strlen(COMPUTER_FILE) + strlen((char *)l->data);

                if(strcmp(mount_dir,BURN)==0)
                    ret = check_has_subdirectory(mount_dir);
                
                //root.link：根目录情况
                else if (path[0] == '\0')
                    ret = TRUE;
                else
                {
                    GString *uri = g_string_new(mount_dir);
                    uri = g_string_append(uri, path);
                    ret = check_has_subdirectory((char *)uri->str + strlen(FILESYSYTEM) - 1);
                    g_string_free(uri, TRUE);
                }
                break;
            }
        }
        g_free (unescape_uri);

        return ret;
    }

    return TRUE;
}

