/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */

/*
 * Caja
 *
 * Copyright (C) 1999, 2000 Eazel, Inc.
 *
 * Caja is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Caja is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Author: Andy Hertzfeld <andy@eazel.com>
 *
 *  This is the header file for the index panel widget, which displays overview information
 *  in a vertical panel and hosts the meta-views.
 */

#ifndef UK_INFORMATION_PANEL_H
#define UK_INFORMATION_PANEL_H

#include "caja-window-info.h"
#include <eel/eel-background-box.h>

#define UK_TYPE_INFORMATION_PANEL uk_information_panel_get_type()
#define UK_INFORMATION_PANEL(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST ((obj), UK_TYPE_INFORMATION_PANEL, UkInformationPanel))
#define UK_INFORMATION_PANEL_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST ((klass), UK_TYPE_INFORMATION_PANEL, UkInformationPanelClass))
#define UK_IS_INFORMATION_PANEL(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UK_TYPE_INFORMATION_PANEL))
#define UK_IS_INFORMATION_PANEL_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE ((klass), UK_TYPE_INFORMATION_PANEL))
#define UK_INFORMATION_PANEL_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_CLASS ((obj), UK_TYPE_INFORMATION_PANEL, UkInformationPanelClass))

typedef struct UkInformationPanelDetails UkInformationPanelDetails;

#define UK_INFORMATION_PANEL_ID "information"

typedef struct
{
    EelBackgroundBox parent_slot;
    UkInformationPanelDetails *details;
} UkInformationPanel;

typedef struct
{
    EelBackgroundBoxClass parent_slot;

    void (*location_changed) (UkInformationPanel *information_panel,
                              const char *location);
} UkInformationPanelClass;

GType            uk_information_panel_get_type     (void);

UkInformationPanel *uk_information_panel_create (CajaWindowInfo *window);
void uk_information_panel_set_parent_window (UkInformationPanel *panel,
        CajaWindowInfo *window);

void uk_information_panel_set_current_session_more_info_text (UkInformationPanel *panel,
        const char *text);


#endif /* UK_INFORMATION_PANEL_H */
