/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 8; tab-width: 8 -*- */

/*
 * Caja
 *
 * Copyright (C) 2000 Eazel, Inc.
 *
 * Caja is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * Author: Andy Hertzfeld <andy@eazel.com>
 */

/*
 * This is the header file for the sidebar title, which is part of the sidebar.
 */

#ifndef UK_SIDEBAR_TITLE_H
#define UK_SIDEBAR_TITLE_H

#include <gtk/gtk.h>
#include <eel/eel-background.h>
#include <libcaja-private/caja-file.h>

#define UK_TYPE_SIDEBAR_TITLE uk_sidebar_title_get_type()
#define UK_SIDEBAR_TITLE(obj) \
  (G_TYPE_CHECK_INSTANCE_CAST ((obj), UK_TYPE_SIDEBAR_TITLE, UkSidebarTitle))
#define UK_SIDEBAR_TITLE_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_CAST ((klass), UK_TYPE_SIDEBAR_TITLE, UkSidebarTitleClass))
#define UK_IS_SIDEBAR_TITLE(obj) \
  (G_TYPE_CHECK_INSTANCE_TYPE ((obj), UK_TYPE_SIDEBAR_TITLE))
#define UK_IS_SIDEBAR_TITLE_CLASS(klass) \
  (G_TYPE_CHECK_CLASS_TYPE ((klass), UK_TYPE_SIDEBAR_TITLE))
#define UK_SIDEBAR_TITLE_GET_CLASS(obj) \
  (G_TYPE_INSTANCE_GET_CLASS ((obj), UK_TYPE_SIDEBAR_TITLE, UkSidebarTitleClass))

typedef struct UkSidebarTitleDetails UkSidebarTitleDetails;

typedef struct
{
    GtkHBox box;
    UkSidebarTitleDetails *details;
} UkSidebarTitle;

typedef struct
{
    GtkHBoxClass parent_class;
} UkSidebarTitleClass;

GType      uk_sidebar_title_get_type          (void);
GtkWidget *uk_sidebar_title_new               (void);
void       uk_sidebar_title_set_file          (UkSidebarTitle *sidebar_title,
		const char* current_session_status_text,
		int current_session_count,
        CajaFile         *file,
        const char           *initial_text);
void       uk_sidebar_title_set_text          (UkSidebarTitle *sidebar_title,
        const char           *new_title);
char *     uk_sidebar_title_get_text          (UkSidebarTitle *sidebar_title);
gboolean   uk_sidebar_title_hit_test_icon     (UkSidebarTitle *sidebar_title,
        int                   x,
        int                   y);
void       uk_sidebar_title_select_text_color (UkSidebarTitle *sidebar_title,
        					 EelBackground        *background);

#endif /* UK_SIDEBAR_TITLE_H */
